From af858db8c99d59cc877dfa104112a8dc93070bad Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 14:07:51 +0000
Subject: [PATCH 29/51] check the profiles


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 3bda078..ad9d775 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -426,3 +426,47 @@ class ModuleMDLinter(object):
         tracker."""
         if 'references' in self.mmd:
             self.check_is_scalar(*self.mmd['references'].values())
+
+    @error
+    @guidelines_link('#Module_profiles')
+    @detail("The 'profiles' block must be a dictionary (key/value).")
+    def lint_profiles_dict(self):
+        """The module author MAY define lists of packages that would be
+        installed by default, and a minimum, when the module is enabled and the
+        particular profile is selected."""
+        if 'profiles' in self.mmd:
+            self.check_is_dict(self.mmd['profiles'])
+
+    @info
+    @guidelines_link('#Module_profiles')
+    @detail("Modules that are supposed to be user-installable should in most"
+            " cases have at least one profile.")
+    @prerequisite('profiles_dict')
+    def lint_profiles_exist(self):
+        """The module author MAY define lists of packages that would be
+        installed by default, and a minimum, when the module is enabled and the
+        particular profile is selected."""
+        self.check('profiles' in self.mmd and len(self.mmd['profiles']))
+
+    @info
+    @guidelines_link('#Module_profiles')
+    @detail("Modules that are supposed to be user-installable should in most"
+            " cases have a 'default' profile.")
+    @prerequisite('profiles_exist')
+    def lint_profiles_has_default(self):
+        """The module author MAY define lists of packages that would be
+        installed by default, and a minimum, when the module is enabled and the
+        particular profile is selected."""
+        self.check('profiles' in self.mmd
+                   and 'default' in self.mmd['profiles'])
+
+    @error
+    @guidelines_link('#Module_profiles')
+    @detail("The 'profiles' block must contain dictionary (key/value) blocks.")
+    @prerequisite('profiles_dict')
+    def lint_profiles_blocks_are_dicts(self):
+        """The module author MAY define lists of packages that would be
+        installed by default, and a minimum, when the module is enabled and the
+        particular profile is selected."""
+        if 'profiles' in self.mmd:
+            self.check_is_dict(*self.mmd['profiles'].values())

